/*
Get a page, grabs id's and makes hidden divs.
Neil wrote a lot of this
Andy fixed it for IE
But a lot of credit goes to slayeroffice, thanks:http://slayeroffice.com/index.php
*/

var helpOn = false;
var helpReady = false;
var helpInitialized;
var activeObj=null;
var helpable = {};
var helpableElms = [];
var oldBehavior = {};
var helpDivs = [];

// DOM NodeType
var ELEMENT_NODE = 1;

function toggleHelp(e) {
    // turns help on and off, this is the external function you call
    if (!helpInitialized) {
        // should only happen once
        initHelp();
        e.innerHTML = "loading"
    }
    
    if (helpOn) {
        stopHelp();
        e.innerHTML = "help"
    } else {
        startHelp();
        e.innerHTML = "help off"
    }

    //return false;
}

function startHelp() {
    // run through all the elements
    if (helpInitialized != true) { return }
    
    for (i = 0; i < helpableElms.length; i++) {
        elm = helpableElms[i];
        
        oldBehavior[elm.id] = {};
        oldBehavior[elm.id]['onmouseover'] = elm.onmouseover;
        oldBehavior[elm.id]['onmouseout'] = elm.onmouseout;
        
        try {
          helpableElms[i].onmouseover=showHelp;
          helpableElms[i].onmouseout=hideHelp;
        } catch(e) {
        }
    }

    helpOn = true;
}

function stopHelp() {
    // opposite of above
    for (i = 0; i < helpDivs.length; i++) {
        helpDivs[i].style.display = 'none';
    }
    
    for (i = 0; i < helpableElms.length; i++) {
        elm = helpableElms[i];
        try {
          helpableElms[i].onmouseover= oldBehavior[elm.id]['onmouseover'];
          helpableElms[i].onmouseout= oldBehavior[elm.id]['onmouseout'];
        } catch(e) {
        }
    }

    helpOn = false;
}

function initHelp() {
    if (helpInitialized == true) { return }
   
    // fetch the help for this page, which will be an HTML page.
    // there will be individual elements within the HTML page which (?)
    // correspond to id elements on or page.
   
    var x = Sarissa.getXmlHttpRequest();
    x.open("GET", "getHelp.xml", false);
    x.send(null);
    parseHelp(x.responseXML);

    helpInitialized = true;
}

function getIdNode(node) {
    // get the id for an XML element, conv. function
   attrs = node.attributes;
   id = null;
   if (attrs) {
        for (var i = 0; i < attrs.length; i++) {
            if (attrs.item(i).name == 'id') {
              id = attrs.item(i).value;
            }
        }
   }
   return id;
}


function parseHelp(helpElm) {
    // bunch of help
    id = getIdNode(helpElm);
    if (attrs) {
          var docElm = document.getElementById(id);
          if (docElm != null) {
              var helpDiv = document.createElement('div');
              helpDiv.className = 'hover_help'
              helpDiv.id = 'hover_help_' + id

              if (helpElm.text) {
                // IE
                 helpDiv.innerHTML = helpElm.text;
              } else { 
                // Moz
                 helpDiv.innerHTML = helpElm.innerHTML;
              }
              
              document.body.appendChild(helpDiv);
              setHelpDown(docElm, helpDiv);
              helpDivs.push(helpDiv);
          }
    }
    var helpKids=helpElm.childNodes;
    for (var i = 0; i < helpKids.length; i++) {
        if (helpKids[i].nodeType == ELEMENT_NODE) {
            parseHelp(helpKids[i]);
       }
    }
}

function setHelpDown(elm, helpDiv) {
    helpableElms.push(elm);

    cn = elm.childNodes;
    for (var i = 0; i < cn.length; i++) {
        setHelpDown(cn[i], helpDiv)
    }
}

function moveHelpDiv(e, helpDiv){
    // move visible, copied from modi.js   
   x=document.all?window.event.clientX+returnScrollDimensions(0):e.clientX;
   y=document.all?window.event.clientY+returnScrollDimensions(1):e.pageY;

   body = document.getElementsByTagName('BODY').item(0);
   if(x+helpDiv.offsetWidth > body.offsetWidth) {
      helpDiv.style.left= (x - helpDiv.offsetWidth)+"px";
   } else {
      helpDiv.style.left=(x+15)+"px";
   }

   yOffset1 = body.scrollTop;
   yOffset2 = document.documentElement.scrollTop;
   if(yOffset1) {
      yOffset = yOffset1;
   } else if (yOffset2) {
      yOffset = yOffset2;
   } else {
      yOffset = 0;
   }
   if(y-helpDiv.offsetHeight<=0 || (y-helpDiv.offsetHeight)<yOffset) {
      helpDiv.style.top=(y+15)+"px";
   } else {
      helpDiv.style.top = (y-helpDiv.offsetHeight) + "px";
   }

}


function hideHelp() {
    // find id and hide
    id = 'hover_help_' + this.id
    el = document.getElementById(id)
    if (el != null) { 
       el.style.display = 'none'; 
    }
}

 
function showHelp(e) {
    // find and show
    id = 'hover_help_' + this.id
    el= document.getElementById(id)
    if (!e) var e = window.event;
    if (el != null) {
        moveHelpDiv(e, el);
        el.style.display = 'block';
    }
}

function returnScrollDimensions(which) {
    // from modi.js
	if(which) {
		if(document.body.scrollTop != 0)return document.body.scrollTop;
		if(document.documentElement.scrollTop != 0)return document.documentElement.scrollTop;
	} else {
		if(document.body.scrollLeft != 0)return document.body.scrollTop;
		if(document.documentElement.scrollLeft != 0)return document.documentElement.scrollLeft;
	}
	return 0;
}
